#include <SD.h>
#include <Servo.h>

#define SD_PIN 10
#define SWITCH_PIN 8
#define BUTTON_PIN 7
#define POTENTIOMETER_PIN A0
#define RED_LED_PIN 5
#define GREEN_LED_PIN 4
#define SERVO_PIN 2

#define FILE_NAME "servo.txt"

File file;
Servo servo;

bool enable = false;

void setup() {
  if (!SD.begin(SD_PIN)) {
    while (true);
  }
  if (SD.exists(FILE_NAME)) {
    SD.remove(FILE_NAME);
  }
  servo.attach(SERVO_PIN);
  pinMode(SWITCH_PIN, INPUT);
  pinMode(BUTTON_PIN, INPUT);
  pinMode(RED_LED_PIN, OUTPUT);
  pinMode(GREEN_LED_PIN, OUTPUT);
}

void loop() {
  if (digitalRead(SWITCH_PIN) == HIGH && !enable) {
    file = SD.open(FILE_NAME, FILE_WRITE);
    digitalWrite(RED_LED_PIN, HIGH);
    enable = true;
    delay(300);
  } else if (digitalRead(SWITCH_PIN) == LOW && enable) {
    file.close();
    digitalWrite(RED_LED_PIN, LOW);
    enable = false;
    delay(300);
  }

  int value = analogRead(POTENTIOMETER_PIN);
  int position = map(value, 0, 1023, 0, 179);
  servo.write(position);
  
  if (!enable) {
    return;
  }

  if (digitalRead(BUTTON_PIN) == HIGH) {
    if (file) {
      digitalWrite(GREEN_LED_PIN, HIGH);
      file.println(position);
      delay(300);
      digitalWrite(GREEN_LED_PIN, LOW);
    }
  }
  delay(10);
}